/* eslint-disable prefer-const */
/* eslint-disable react/jsx-handler-names */
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import ReactDOM from 'react-dom';
import classNames from 'classnames';

export class DropdownPanel extends Component {
	renderElement() {
		const { children, filter, onClick, panelClassName, panelStyle, scrollHeight } = this.props;
		let className = classNames('p-dropdown-panel p-hidden p-input-overlay', panelClassName);

		return (
			<div
				ref={el => (this.element = el)}
				className={className}
				style={panelStyle}
				onClick={onClick}
			>
				{filter}
				<div
					ref={el => (this.itemsWrapper = el)}
					className="p-dropdown-items-wrapper"
					style={{ maxHeight: scrollHeight || 'auto' }}
				>
					<ul tabIndex="1" className="p-dropdown-items p-dropdown-list p-component" role="list">
						{children}
					</ul>
				</div>
			</div>
		);
	}

	render() {
		const { appendTo } = this.props;
		let element = this.renderElement();

		if (appendTo) {
			return ReactDOM.createPortal(element, appendTo);
		} else {
			return element;
		}
	}
}

DropdownPanel.defaultProps = {
	appendTo: null,
	filter: null,
	scrollHeight: null,
	panelClassName: null,
	panelStyle: null,
	onClick: null,
};

DropdownPanel.propTypes = {
	appendTo: PropTypes.object,
	children: PropTypes.oneOfType([PropTypes.arrayOf(PropTypes.node), PropTypes.node]),
	filter: PropTypes.any,
	onClick: PropTypes.func,
	panelClassName: PropTypes.string,
	panelStyle: PropTypes.object,
	scrollHeight: PropTypes.string,
};

export default DropdownPanel;
